"""
Copyright 2011,  Leif Theden & Michael Bachmann


This file is part of Nein.

Nein is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Nein is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Nein.  If not, see <http://www.gnu.org/licenses/>.
"""

import pygame
import lib.gfx as gfx

try:
    pygame.init()
    pygame.font.init()
except pygame.error:
    raise Exception, "Pygame could not initialize."

try:
    pygame.mixer.init()
except pygame.error:
    print "Cannot initialize pygame sound mixer."
    print "Sound and music will not work."

try:
    gfx.init()
except:
    raise Exception, "Pygame graphics could not initialize."

from resources.titlescreen import TitleScreen
from resources.world import Level1
from lib.engine import StateDriver

class Game(object):
    def __init__(self):
        pass

    def load_config(self, location):
        pass

    def get_screen(self):
        return gfx.screen

    def start(self):
        sd = StateDriver(self)
        sd.push(Level1(sd))
        sd.start(TitleScreen(sd))
        sd.run()

if __name__ == "__main__":
    game = Game()
    game.start()
    pygame.quit()
    print "Thanks for playing!"
