"""
Copyright 2011,  Leif Theden & Michael Bachmann


This file is part of Nein.

Nein is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Nein is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Nein.  If not, see <http://www.gnu.org/licenses/>.
"""

import Box2D as b2d
import pygame
from sprite import PhysicsSprite
from buildutils import *
import gfx

class LevelSprite(PhysicsSprite):
    pass

def beachball(world, pos):
    image = gfx.load_colorkey("beachball.gif")
    image = pygame.transform.scale(image, (20, 20))

    shapeDef = b2d.b2CircleDef()
    shapeDef.density = 1
    shapeDef.friction = 1
    shapeDef.restitution = 0.75

    r = image.get_rect()
    shapeDef.radius = world.toWorld((r.width/ 2, r.width))[0]
    #shapeDef.localPosition = (0,0)

    bodyDef = build_body_def(world, pos)
    body = world.world.CreateBody(bodyDef)
    body.CreateShape(shapeDef)
    body.SetMassFromShapes()

    return PhysicsSprite(image, body)

def trampoline(world, pos):
    image = gfx.load_colorkey("tramp1.gif")
    image = pygame.transform.scale(image, (50, 30))
    body = build_body(world, image, pos=pos, density=5, r=0, friction=1)
    return PhysicsSprite(image, body)

# swing away....
def slugger(world, pos):
    image = gfx.load("bat.png")
    image = pygame.transform.scale(image, (70,10))
    body = build_body(world, image, pos=(pos[0]-7, pos[1]-5), density=50)

    pos = world.toWorld(pos)

    bd = b2d.b2BodyDef()
    bd.position = pos
    mount = world.world.CreateBody(bd)

    cd=b2d.b2CircleDef() 
    cd.isSensor = True
    cd.radius = 8.0
    body.CreateShape(cd)

    jd = b2d.b2RevoluteJointDef()
    jd.Initialize(mount, body, pos)

    world.world.CreateJoint(jd)

    return PhysicsSprite(image, body)
