"""
Copyright 2011,  Leif Theden & Michael Bachmann


This file is part of Nein.

Nein is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Nein is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Nein.  If not, see <http://www.gnu.org/licenses/>.
"""

import pygame, os.path, sys

root = "resources/audio"


DEBUG = True

def debug(text):
    if DEBUG: sys.stdout.write(text)


sound_cache = {}

class NoSound:
    def play(self): 
        print "BEEP!  (this is an error)"

dummy = NoSound()

def load_music(name):
    pygame.mixer.music.load(os.path.join(root, name))

def play_music(*args):
    pygame.mixer.music.play(*args)

def load(name):
    global sound_cache

    if not pygame.mixer:
        debug("Cannot load sound: pygame.mixer not ready\n")
        return dummy

    fullpath = os.path.join(root, name)

    # try to the the cache first
    #try:
    #    return sound_cache[fullpath]
    #except KeyError:
    #    pass

    # pygame will load a sound even if it doesn't exist... do a sanity check.
    open(fullpath).close()

    try:
        sound = pygame.mixer.Sound(fullpath)
    except pygame.error, message:
        debug("Cannot load sound: %s\n" % fullpath)
        debug("%s\n" % message)
        return dummy

    # update the cache
    #sound_cache[fullpath] = sound

    return sound

